/**
 * generated by Xtext 2.22.0
 */
package tdt4250.ra.tests;

import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.extensions.InjectionExtension;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import tdt4250.ra.Department;
import tdt4250.ra.tests.RaxInjectorProvider;

@ExtendWith(InjectionExtension.class)
@InjectWith(RaxInjectorProvider.class)
@SuppressWarnings("all")
public class RaxParsingTest {
  @Inject
  private ParseHelper<Department> parseHelper;
  
  @Test
  public void loadModel() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("IDI - \"Dept. of CS\"");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Persons:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("\"Hallvard Trætteberg\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("Adrian");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("Yngve");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("Courses:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("TDT4250 - \"Advanced Software Design\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("requires lecturer for 0.8, exerciseTA for 0.2");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("provided-by \"Hallvard Trætteberg\" is 1.0 as lecturer \"Hallvard Trætteberg\" is 1.0 as exerciseTA");
      _builder.newLine();
      _builder.newLine();
      _builder.append("\t");
      _builder.append("IT1901 - \"Informatics Project\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("requires lecturer for 0.6, coordinator for 0.4");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("provided-by Adrian is 1.0 as lecturer Adrian is 0.7 as coordinator \"Hallvard Trætteberg\" is 0.5 as coordinator");
      _builder.newLine();
      _builder.newLine();
      _builder.append("\t");
      _builder.append("TDT4180 - \"Human-Computer Interaction\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("requires lecturer for 1.0");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("provided-by Yngve is 1.0 as lecturer");
      _builder.newLine();
      final Department dep = this.parseHelper.parse(_builder);
      Assertions.assertNotNull(dep);
      final EList<Resource.Diagnostic> errors = dep.eResource().getErrors();
      Assertions.assertEquals("IDI", dep.getShortName());
      Assertions.assertEquals("Dept. of CS", dep.getName());
      Assertions.assertEquals(3, dep.getStaff().size());
      boolean _isEmpty = errors.isEmpty();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assertions.assertTrue(_isEmpty, _builder_1.toString());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
